#include<bits/stdc++.h>
using namespace std;
int n,q;
vector<int> to[500005];
int f[500005][20],dep[500005];
void dfs(int x=1,int fa=0){
    dep[x]=dep[fa]+1;
    f[x][0]=fa;
    for(int i=1;i<=19;i++)f[x][i]=f[f[x][i-1]][i-1];
    for(auto ed:to[x]){
        if(ed==fa)continue;
        dfs(ed,x);
    }
}
int lca(int x,int y){
    if(!x||!y)return x+y;
    if(dep[x]<dep[y])swap(x,y);
    if(dep[x]!=dep[y]){
        for(int i=19;i>=0;i--){
            if(dep[f[x][i]]>=dep[y])x=f[x][i];
        }
    }
    if(x==y)return x;
    for(int i=19;i>=0;i--){
        if(f[x][i]!=f[y][i]){
            x=f[x][i];
            y=f[y][i];
        }
    }
    return f[x][0];
}
int v[2000005];
void pushup(int x){
    v[x]=lca(v[x<<1],v[x<<1|1]);
}
void build(int x=1,int l=1,int r=n){
    if(l==r)return v[x]=l,void(0);
    int mid=(l+r)>>1;
    build(x<<1,l,mid);build(x<<1|1,mid+1,r);
    pushup(x);
}
int que(int ll,int rr,int x=1,int l=1,int r=n){
    if(ll>rr)return 0;
    if(ll<=l&&r<=rr)return v[x];
    int mid=(l+r)>>1,res=0;
    if(ll<=mid)res=lca(res,que(ll,rr,x<<1,l,mid));
    if(mid<rr)res=lca(res,que(ll,rr,x<<1|1,mid+1,r));
    return res;
}
int deg[500005],d1,d2;
signed main(){
    freopen("query.in","r",stdin);
    freopen("query.out","w",stdout);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    for(int i=1;i<n;i++){
        int u,v;
        cin>>u>>v;
        to[u].push_back(v);
        to[v].push_back(u);
        if(deg[u]==0)d1++;
        else if(deg[u]==1)d1--,d2++;
        else d2--;
        if(deg[v]==0)d1++;
        else if(deg[v]==1)d1--,d2++;
        else d2--;
        deg[u]++,deg[v]++;
    }
    dfs();
    cin>>q;
    if(n==1){
        while(q--){
            int l,r,k;
            cin>>l>>r>>k;
            cout<<"1\n";
        }
    }
    else{
        build();
        while(q--){
            int l,r,k,ans=0;
            cin>>l>>r>>k;
            for(int i=l,j=l+k-1;j<=r;i++,j++){
                int res=que(i,j);
                if(!ans||dep[ans]<dep[res])ans=res;
            }
            cout<<dep[ans]<<'\n';
        }
    }
    return 0;
}